<?php
/**
 * MVClasses
 *
 * LICENSE
 *
 * "THE BEER-WARE LICENSE" (Revision 42):
 * "Sven Strittmatter" <ausserirdisch@sven-space.de> wrote this file.
 * As long as you retain this notice you can do whatever you want with
 * this stuff. If we meet some day, and you think this stuff is worth it,
 * you can buy me a beer in return.
 *
 * @category    MVClasses
 * @package     Event
 * @copyright   Copyright (c) 2007 Sven Strittmatter
 */

/**
 * @see Event
 */
require_once dirname(__FILE__)."/Event.php";

/**
 * Enter description here...
 *
 * Longdesc
 *
 * @todo complete description
 *
 * @category    MVClasses
 * @package 	Event
 * @copyright 	Copyright (c) 2007 Sven Strittmatter
 * @author	"Sven Strittmatter" <ausserirdisch@sven-space.de>
 * @version 	1.0
 * @link        http://www.sven-space.de/code/php/MVClasses
 */
class EventDispatcher {
    /**
     * @static
     * @access private
     * @var EventDispatcher
     */
    private static $_instance;
    /**
     * @access private
     * @var array
     */
    private $_handlers;

    /**
     * Singleton
     */
    protected function __construct() {
        $this->_handlers = array();
    }

    /**
     * Singleton
     */
    protected function __clone() {}

    public static function getInstance() {
        if (null === self::$_instance) {
            self::$_instance = new EventDispatcher();
        }

        return self::$_instance;
    }

    public function addHandler($name, EventHandler $handler) {
        if (!isset($this->_handlers[$name])) {
            $this->_handlers[$name] = array();
        }

        $this->_handlers[$name][] = $handler;
    }

    public function triggerEvent($event, $context = null, $info = null) {
        if (!$event instanceof Event) {
            $event = new Event($event, $context, $info);
        }

        $name = $event->getName();

        if (!isset($this->_handlers[$name])) {
            return $event;
        }

        foreach ($this->_handlers[$name] as $handler) {
            $handler->handle($event);

            if ($event->isCancelled()) {
                break;
            }
        }

        return $event;
    }
}