<?php
/**
 * MVClasses
 *
 * LICENSE
 *
 * "THE BEER-WARE LICENSE" (Revision 42):
 * "Sven Strittmatter" <ausserirdisch@sven-space.de> wrote this file.
 * As long as you retain this notice you can do whatever you want with
 * this stuff. If we meet some day, and you think this stuff is worth it,
 * you can buy me a beer in return.
 *
 * @category    MVClasses
 * @package     Filter
 * @copyright   Copyright (c) 2007 Sven Strittmatter
 */

/**
 * @see Filter
 */
require_once dirname(__FILE__)."/Filter.php";
/**
 * @see EventDispatcher
 */
require_once dirname(__FILE__)."/../Event/EventDispatcher.php";

/**
 * Enter description here...
 *
 * Longdesc
 *
 * @todo complete description
 *
 * @category    MVClasses
 * @package 	Filter
 * @copyright 	Copyright (c) 2007 Sven Strittmatter
 * @author	"Sven Strittmatter" <ausserirdisch@sven-space.de>
 * @version 	1.0
 * @link        http://www.sven-space.de/code/php/MVClasses
 */
class HttpAuthFilter implements Filter {
    private $_auth_data;

    public function __construct($auth_data) {
        $this->_auth_data = $auth_data;
    }

    public function execute(Request $req, Response $res) {
        $auth_data = $req->getAuthData();

        if (null === $auth_data) {
            $this->_sendAuthRequest($res);
        }

        if (!isset($this->_auth_data[$auth_data['username']]) ||
            $this->_auth_data[$auth_data['username']] !== $auth_data['password']) {
            EventDispatcher::getInstance()->triggerevent("onInvalidLogin", $this, $auth_data);
            $this->_sendAuthRequest($res);
        }

        $event = EventDispatcher::getInstance()->triggerEvent("onLogin", $this, $auth_data);

        if ($event->isCancelled()) {
            $this->_sendAuthRequest($res);
        }
    }

    private function _sendAuthRequest(Response $r) {
        $r->setStatus(HttpResponse::HTTP_STATUS_401);
        $r->addHeader("WWW-Authenticate", "Basic realm=\"RealCommunity\"");
        $r->flush();
        exit;
    }
}