<?php
/**
 * MVClasses
 *
 * LICENSE
 *
 * "THE BEER-WARE LICENSE" (Revision 42):
 * "Sven Strittmatter" <ausserirdisch@sven-space.de> wrote this file.
 * As long as you retain this notice you can do whatever you want with
 * this stuff. If we meet some day, and you think this stuff is worth it,
 * you can buy me a beer in return.
 *
 * @category    MVClasses
 * @package     TemplateView
 * @copyright   Copyright (c) 2007 Sven Strittmatter
 */

/**
 * Enter description here...
 *
 * Longdesc
 *
 * @todo complete description
 *
 * @category    MVClasses
 * @package 	TemplateView
 * @copyright 	Copyright (c) 2007 Sven Strittmatter
 * @author	"Sven Strittmatter" <ausserirdisch@sven-space.de>
 * @version 	1.0
 * @link        http://www.sven-space.de/code/php/MVClasses
 */
class TemplateView {
    private $_template;
    private $_vars;
    private $_helpers;

    public function __construct($template) {
        $this->_template = $template;
        $this->_vars = array();
        $this->_helpers = array();
    }

    public function assign($name, $value) {
        $this->_vars[$name] = $value;
    }

    public function render(Request $req, Response $res) {
        ob_start();
        include_once $this->_template;
        $res->write(ob_get_clean());
    }

    public function __get($name) {
        if (isset($this->_vars[$name])) {
            return $this->_vars[$name];
        }

        return null;
    }

    public function __call($name, $args) {
        $helper = $this->_loadViewHelper($name);

        if (null === $helper) {
            throw new Exception("Unknown view helper: $name");
        }

        return $helper->execute($args);
    }

    protected function _loadViewHelper($helper) {
        $name = ucfirst($helper);

        if (!isset($this->_helpers[$helper])) {
            $class = $name."ViewHelper";

            $file = dirname($this->_template)."/ViewHelpers/{$class}.php";

            if (!file_exists($file)) {
                return null;
            }

            include_once $file;
            $this->_helpers[$helper] = new $class();
        }

        return $this->_helpers[$helper];
    }
}